#pragma once

#include <opencv2/opencv.hpp>

#include "feature.hpp"

class Match;

cv::Mat applyHomography(cv::Mat& H, cv::Mat& quad);
cv::Mat getDistortedCorners(cv::Size size, cv::Mat& H);
double getDistortedAreaFrac(cv::Size size, cv::Mat& H);
cv::Point2f applyHomography(cv::Mat& H, cv::Point2f in);
cv::Mat combine(cv::Mat& H, cv::Mat& im1, cv::Mat& im2,
                cv::Mat& G, cv::Point2f& offset);
cv::Mat findBestHomography(std::vector<Match>& matches);
cv::Mat findBestHomography(cv::Mat& im1, cv::Mat& im2);
cv::Mat findBestHomographyMK(std::vector<Match>& matches);