#pragma once

#include <opencv2/opencv.hpp>

#include <string>
#include <vector>

struct Feature {
    cv::Mat f;
    cv::Point2f loc;
    Feature(cv::Mat& feature, cv::Point2f l);
};

std::vector<Feature> getFeatures(cv::Mat& im, std::vector<cv::Point2f> corners);
std::vector<Feature> getFeatures(cv::Mat& im);