#pragma once

#include <opencv2/opencv.hpp>

#include "calibration.hpp"
#include "cylinder.hpp"
#include "helpers.hpp"
#include "homography.hpp"
#include "mask.hpp"
#include "match.hpp"
#include "rotation.hpp"

cv::Mat stitchPan(std::vector<cv::Mat> images);
cv::Mat stitchPanI(std::vector<cv::Mat> images);
cv::Mat stitchPanI(std::vector<cv::Mat> images, size_t imageNum);